// -*-c++-mode-*-
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//

#ifndef _RAP_H_
#define _RAP_H_

#include "FDInterest.h"

class RAP : public FDInterest {
private:
    static IceListenObj	*listeners;
    static int		majorOpcode;
    static char		*networkIds;
    static Window	agentWindow;
    static Atom		protoNameAtom;
    static Display	*dpy;

    static AuthProc;
    static IOErrorHandler;

    IceConn		iceConn;
    Window		clientWindow;

protected:

public:
    RAP();
    virtual ~RAP();

    static int		Register(Display *dpy);
    static int		InitiateConnection(Window clientWindow);

    virtual int		HandleActivity(int fd, short type);
    virtual void	Shutdown(int fd);

    //
    // Requests from agent
    //
    int			HelloRequest();
    int			QueryTreeRequest();
    int			GetResourcesRequest();
    int			GetValuesRequest();
    int			SetValuesRequest();
    int			WindowToObjectRequest();
    int			ObjectToWindowRequest();
    int			ObjectLocationRequest();
    int			SelectEventRequest();
    int			SelectRequestRequest();
    int			AddNotifyRequest();
    int			RemoveNotifyRequest();
    int			CloseConnectionRequest();
};

#endif /* _RAP_H_ */
