/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
/************************************************************************/
/*									*/
/* Rap.h								*/
/*									*/
/*	Header file for RAP (Remote Access Protocol).			*/
/*     									*/
/************************************************************************/

#ifndef _RAP_H_
#define _RAP_H_


/* prototypes */
int HandleRapHelloRequest(IceConn, int, Widget);
int HandleRapQueryTreeRequest(IceConn, int, Widget);
int HandleRapGetValuesRequest(IceConn, int);
int HandleRapSetValuesRequest(IceConn, int);
int HandleRapGetResourcesRequest(IceConn, int);
int HandleRapGetGCValuesRequest(IceConn, int, Widget);
int HandleRapAddNotifyRequest(IceConn, int, Widget);
int HandleRapRemoveNotifyRequest(IceConn, int);
int HandleRapSelectEventRequest(IceConn, int, Widget);
int HandleRapSelectRequestRequest(IceConn, int, Widget);
int HandleRapObjectToWindowRequest(IceConn, int);
int HandleRapWindowToObjectRequest(IceConn, int);

int RAPHelloReply(IceConn, int, Widget);
int RAPQueryTreeReply(IceConn, int, Widget);
int RAPFullQueryTreeReply(IceConn, int, Widget);


int RapEventProc();
int RapFlushProc();
int RapGCFlushProc();

void RapDestroyHookProc(Widget, XtPointer, XtPointer);
void RapCreateHookProc(Widget, XtPointer, XtPointer);
void RapConfigureHookProc(Widget, XtPointer, XtPointer);
void RapGeometryHookProc(Widget, XtPointer, XtPointer);
void RapChangeHookProc(Widget, XtPointer, XtPointer);



#endif /*_RAP_H_ */
