/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
 * Routines for converting from GContexts back to GCs.  This code is
 * inserted into Xlib to maintain a client-side mapping from GContexts
 * to GCs.
 *
 *	Written by Sue Long <suelong@cc.gatech.edu>
 *	Clean-up by Keith Edwards <keith@cc.gatech.edu>
 *
 */

#include "XGCList.h"

static XGCListPtr XGCListHead = NULL;

GC
XGCFromGContext(dpy, gid)
    Display *dpy;
    GContext gid;
{
    XGCListPtr temp = XGCListHead;
    int done = 0;

    while (!done) {
	if (temp) {
	    if ((gid == XGContextFromGC(temp->gc)) && (dpy == temp->dpy))
	        done = 1;
	    else
		temp = temp->next;
	} else {
	    done = 1;
	}
    }

    if (temp)
	return temp->gc;
    else
	return NULL;
}

XGCListPtr
XGCGetListHead()
{
    return XGCListHead;
}

void
XGCSetListHead(newhead)
    XGCListPtr newhead;
{
    XGCListHead = newhead;
}

