/*
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
/************************************************************************/
/*									*/
/* client.c								*/
/*									*/
/*	Test application that just creates a push button in its window.	*/
/*	It also makes a call to RapInstall using the toplevel shell.	*/
/*									*/
/************************************************************************/
#include <stdio.h>
#include <X11/Xmd.h>
#include <X11/Xlib.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include "XGCList.h"

#if 0
extern XGCListPtr XGCListHead;
#endif

int	createdit = 0;

Arg		argList[10];
int		argCnt=0;    
Widget		topLevel,mainWindow;
XtAppContext	appContext;
GC              gc = NULL;
GC              gc1 = NULL;
XGCValues       gcv1, gcv2;
Window		win;
 
#define ValidGCValuesBits (GCFunction | GCPlaneMask | GCForeground | \
                           GCBackground | GCLineWidth | GCLineStyle | \
                           GCCapStyle | GCJoinStyle | GCFillStyle | \
                           GCFillRule | GCTile | GCStipple | \
                           GCTileStipXOrigin | GCTileStipYOrigin | \
                           GCFont | GCSubwindowMode | GCGraphicsExposures | \
                           GCClipXOrigin | GCClipYOrigin | GCDashOffset | \
                           GCArcMode)
 
 


/************************************************************************/
/*									*/
/* Application Resources						*/
/*									*/
/************************************************************************/
typedef struct 
{
    int		mode;
} OptionsRec;

OptionsRec options;

#define Offset(field) XtOffsetOf(OptionsRec,field)
XtResource resources[] = 
{
    {"mode", "Mode", XtRInt, sizeof(int),
     Offset(mode), XtRImmediate, (XtPointer) 1},
    NULL
};
#undef Offset

String fallbackResources[] = 
{
    "*mainWindow.width: 100",
    "*mainWindow.height: 100",
    NULL
};

XrmOptionDescRec optionDesc[] = 
{
    {"-mode", "*mode", XrmoptionSepArg, (XtPointer) 1},
};

/************************************************************************/
/*									*/
/* buttonProc - called when the button is pressed.			*/
/*									*/
/************************************************************************/
void buttonProc(Widget 		w, 
		XtPointer 	clientData, 
		XtPointer	*callbackData)
{
    printf("client: buttonProc\n");
    gcv1.foreground = XBlackPixel(XtDisplay(w),
                XDefaultScreen(XtDisplay(w)) );

#if 0
    if (!createdit)
    {
      printf("creating gc\n");
       gc1 = XCreateGC(XtDisplay(w), XtWindow(w), GCForeground & GCBackground,
                &gcv1);
      printf("just created it\n");
	createdit = 1;
    }
#endif	
    
} /* buttonProc */


void testProc(Widget            w,
              XtPointer         clientData,
              XtPointer         *callbackData)
{
	XGCValues gvv;
	static GC newgc;
        Atom test_atom;
        /* lets try something simple, like interning an atom .. */
        printf("about to do  xinternatom \n");
        test_atom = XInternAtom(XtDisplay(w), "testit", FALSE);

 	 if (!createdit)
    	{

#if 0
	  gvv.foreground = XBlackPixel(XtDisplay(w), XDefaultScreen(XtDisplay(w)));
	  gvv.background = XBlackPixel(XtDisplay(w), XDefaultScreen(XtDisplay(w)));
          printf("creating gc\n");
           newgc = XCreateGC(XtDisplay(w), XtWindow(w), GCForeground & GCBackground,
                &gvv);
#endif
         printf("just created it\n");
	 	XDrawLine(XtDisplay(topLevel), XtWindow(topLevel), gc, 0, 0, 100, 100);
	printf("just drew ...\n");
        createdit = 1;
	XFlush(XtDisplay(w));
	XClearArea(XtDisplay(w), XtWindow(w), 0, 0, 0, 0, True);
        }

 
}


/************************************************************************/
/*									*/
/* CreateUI								*/
/*									*/
/************************************************************************/
void CreateUI(Widget topLevel)
{
    Widget someButton, anotherButton;

    XColor screen;
    Display *dpy = XtDisplay(topLevel);	
   


    mainWindow = XtCreateManagedWidget("mainWindow", 
				       boxWidgetClass, 
				       topLevel,
				       NULL, 0);



    someButton = XtVaCreateManagedWidget("listButton", 
					 commandWidgetClass, 
					 mainWindow,
					 XtNlabel,"Push Me",
					 NULL);


    anotherButton = XtVaCreateManagedWidget("TestEvents",
                                         commandWidgetClass,
                                         mainWindow,
                                         XtNlabel,"TestEvents",
                                         NULL);

    XtAddCallback(someButton,XtNcallback,(XtCallbackProc)buttonProc,0);

    XtAddCallback(anotherButton,XtNcallback,(XtCallbackProc)testProc,0); 
    
    
} /* CreateUI */

/************************************************************************/
/*									*/
/* Main routine								*/
/*									*/
/************************************************************************/
main(int argc, char **argv)
{
    /********************************************************************/
    /*									*/
    /* Initialize the toolkit.						*/
    /*									*/
    /********************************************************************/
    GContext id1, id2;

    topLevel = XtAppInitialize(&appContext,
			       "client",
			       optionDesc,XtNumber(optionDesc),
			       &argc,argv,
			       fallbackResources,
			       NULL,0);

    XteaSetupClient(topLevel);

    CreateUI(topLevel);
    
    XtRealizeWidget(topLevel);


    /* ok, create the gc!!  set forground color to black */
    gcv1.foreground = XBlackPixel(XtDisplay(mainWindow),
                XDefaultScreen(XtDisplay(mainWindow)) );


    gc = XCreateGC(XtDisplay(topLevel), XtWindow(topLevel), GCForeground,
                &gcv1);


    XtAppMainLoop(appContext);
    
 

} /* main */
