/*
  this is a fake poll command using select.
  it will grow slowly as I gain understanding of it all.
  following is the definition borrowed from 
  /usr/include/sys/poll.h
  this is part of the solaris 2.5 distribution.
  Joel Zimba November 13, 1996
*/
#ifdef __cplusplus
extern "C" {
#endif

#include <errno.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

//since timeout cannot be negative, we willl use this
//for now.  
#define INFTIM -999

/*
 * Testable select events
 */
#define	POLLIN		0x0001		/* fd is readable */
#define	POLLPRI		0x0002		/* high priority info at fd */
#define	POLLOUT		0x0004		/* fd is writeable (won't block) */
#define	POLLRDNORM	0x0040		/* normal data is readable */
#define	POLLWRNORM	POLLOUT
#define	POLLRDBAND	0x0080		/* out-of-band data is readable */
#define	POLLWRBAND	0x0100		/* out-of-band data is writeable */

#define	POLLNORM	POLLRDNORM

/*
 * Non-testable poll events (may not be specified in events field,
 * but may be returned in revents field).
 */
#define	POLLERR		0x0008		/* fd has error condition */
#define	POLLHUP		0x0010		/* fd has been hung up on */
#define	POLLNVAL	0x0020		/* invalid pollfd entry */

/*
 * Structure of file descriptor/event pairs supplied in
 * the poll arrays.
 */
typedef struct pollfd {
  int fd;				/* file desc to poll */
  short events;			/* events of interest on fd */
  short revents;			/* events that occurred on fd */
} pollfd;

int poll(pollfd *fds,unsigned long nfds, int timeout);

#ifdef __cplusplus
}
#endif
