//  -*-Mode: C++-*-
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
// $Author: keith $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/Action.cc,v $
// $Revision: 6.5 $
// $Date: 1995/10/14 21:21:53 $
// $Log: Action.cc,v $
// Revision 6.5  1995/10/14  21:21:53  keith
// Got rid of damned annoying "no such action" message.
//
// Revision 6.4  1995/09/25  21:04:24  keith
// Got rid of some debugging output...
//
// Revision 6.3  1995/07/28  13:59:22  spine
// Added copyright notice.
//
// Revision 6.2  1995/07/01  20:02:19  spine
// Removed all references to LEDA strings and LEDA.
//
// Revision 6.1  1995/06/10  15:22:22  iansmith
// template update
//
// Revision 1.1  1995/06/10  15:20:57  iansmith
// Initial revision
//
// Revision 6.1  1995/06/09  13:12:32  iansmith
// Changed all the old LEDA dictonaries over to the new mercator
// dictionaries.
//
// Revision 6.0  1995/05/20  22:20:21  beth
// Mercator Version 6
//
// Revision 1.1  1995/05/20  22:15:59  beth
// Initial revision
//
// Revision 1.3  1995/03/06  17:52:05  keith
// *** empty log message ***
//
// Revision 1.2  1995/01/19  22:23:31  keith
// Automatic global checkin
//
// Revision 1.1  1994/11/16  20:46:23  spine
// Initial revision
//
// Revision 1.1  1994/11/16  20:46:23  spine
// Initial revision
//
// Revision 1.1  1994/05/24  19:49:25  stacy
// Initial revision
//
// Revision 1.2  1994/05/22  21:11:58  kathryn
// *** empty log message ***
//
// Revision 1.1  1994/04/06  19:43:33  kathryn
// Initial revision
//
//

static const char rcsid[]="@(#) $header$";

#include <iostream.h>
#include "Action.h"
#include "TclAction.h"
#include "Error.h"
#include "Util.h"

#ifdef xxx
// hashing for string
static unsigned stringHash(const string &s) {
    union {
	unsigned uns;
	unsigned char c[sizeof(unsigned)];
    } result;
    result.uns=0;
    for (int i=0; i<s.length(); ++i) {
	result.c[i%(sizeof(unsigned))]^=(unsigned char)s[i];
    }
    return result.uns;
}
#endif

//
// String hasher for dictionaries.
//
static unsigned StringHasher(const mString& str) { return str.hash(); }


mDictValPtr<mString,Action> *Action::actions = new mDictValPtr<mString,Action>(StringHasher);

// ************************************************************************
// **                          Special Functions                     ******
// ************************************************************************

Action::Action(const char *n) :
    name(Strdup(n))
{
    Action::CreateAction(this, name);
}

Action::~Action()
{
    Action::DeleteAction(name);
    delete [] name;
}

// ************************************************************************
// **                          Private Functions                     ******
// ************************************************************************

void
Action::CreateAction(Action *action, const char *name)
{
    mString actionName(name);
    actions->insert(actionName, action);
}

void
Action::DeleteAction(const char *name)
{
    mString actionName(name);
    
    if (actions->lookup(actionName) == nil)
	Error(EL_ERROR, "Action::DeleteAction",
	      "action ", name, " was never inserted.", NULL);
    else
	actions->del(actionName);
}

// ************************************************************************
// **                          Public Functions                      ******
// ************************************************************************

int
Action::Invoke(const char *name, int argc, char *argv[], const char **result)
{ 
    Action *action;
    mString actionName(name);
  
    if ((action = actions->lookup(actionName)) == nil) {
	//Error(EL_DEBUG, "Action::Invoke", "No such action: ", name, NULL);
	return 0;
    }
    
    return action->Invoke(argc, argv, result);
}

// ************************************************************************
