//
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
//
//

#include "Audio.h"
#include "Util.h"
#include "Error.h"


Audio::Audio(const char *name)
{
    if (name)
	audioName = Strdup(name);
    else
	audioName = Strdup("Generic");
    
    Error(EL_DEBUG, "Audio::Audio", "Creating...", NULL);
}

Audio::~Audio()
{
    Error(EL_DEBUG, "Audio::Audio", "Destroying...", NULL);

    delete [] audioName;
}

Audio::SoundID
Audio::PlaySound(const char *soundFile, float *rate, int volume,
		 int muffle, int looped)
{
    Error(EL_DEBUG, "Audio::PlaySound", "playing ", soundFile, NULL);
    return 0L;
}

int
Audio::StopSound(SoundID id)
{
    Error(EL_DEBUG, "Audio::StopSound", "stopping", NULL);
    return 1;
}

int
Audio::StopAllSounds()
{
    Error(EL_DEBUG, "Audio::StopAllSounds", "stopping", NULL);
    return 1;
}
