// -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
//
//	Base class for Mercator audio loadables.  Unfortunately we have to make
//	some assumptions about the format of any derived Audio objects here
//	(stuff like sound_id's).
//
//		keith edwards	13march95
//

#ifndef _MERCATOR_AUDIO_H_
#define _MERCATOR_AUDIO_H_

#include <stdlib.h>
#include "Error.h"

class Audio {
private:
    char		*audioName;
    
public:
    Audio(const char *name = NULL);
    virtual ~Audio();

    typedef long	SoundID;

    virtual SoundID	PlaySound(const char *soundFile, float *rate,
				  int volume, int muffle, int looped);
    virtual int		StopSound(SoundID);
    virtual int		StopAllSounds();

    virtual void        ShutDown();
    
    const char 		*GetAudioName() const;
};

inline const char *
Audio::GetAudioName() const
{
    return audioName;
}

inline void
Audio::ShutDown()
{
    Error(EL_DEBUG, "Speech::ShutDown", "Shutting down speech subsystem",
	  NULL);
}

#endif /* _MERCATOR_AUDIO_H_ */
