// -*-Mode: C++-*- 
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
// 
//	Dynaloader - interface to SunOS 5.x dynamic loading. 
// 
//		keith edwards 11dec93 
// 
/************************************************************************** 
 * REVISION LOG 
 * 
 * $Author: keith $ 
 * $Source: /net/hm10/keith/proj/mercator/6.0/RCS/DynaLoader.h,v $ 
 * $Revision: 6.5 $ 
 * $Date: 1995/08/18 15:20:19 $ 
 * $Log: DynaLoader.h,v $
 * Revision 6.5  1995/08/18  15:20:19  keith
 * fixed constness on SearchPath() method...was causing warnings.
 *
 * Revision 6.4  1995/07/28  20:31:51  spine
 * Added copyright notice.
 *
 * Revision 6.3  1995/07/01  20:03:30  spine
 * Removed all references to LEDA strings and LEDA.
 *
 * Revision 6.2  1995/06/06  17:59:54  spine
 * now includes the template header from the current dir instead of DS/
 *
 * Revision 6.1  1995/06/02  18:25:38  iansmith
 * Removed all traces of LEDA lists.
 * Included the new mercator lists.
 * Added the search path list (list of strings) and changed the
 * SearchPath() function to return the right type.
 *
 * Revision 6.0  1995/05/20  22:20:21  beth
 * Mercator Version 6
 *
 * Revision 1.1  1995/04/01  19:40:38  keith
 * End of work by Keith
 *
// Revision 1.5  1994/09/18  16:09:54  keith
// Automatic global checkin
//
// Revision 1.5  1994/09/18  16:09:54  keith
// Automatic global checkin
//
// Revision 1.4  1994/09/18  16:08:36  keith
// Automatic global checkin
//
// Revision 1.4  1994/09/18  16:08:36  keith
// Automatic global checkin
//
// Revision 1.3  1994/05/18  19:00:27  iansmith
// Added support for the FeatureSet and Naming conventions.
//
// Revision 1.3  1994/05/18  19:00:27  iansmith
// Added support for the FeatureSet and Naming conventions.
//
// Revision 1.2  1994/05/09  16:11:19  keith
// *** empty log message ***
//
 * 
 **************************************************************************/ 

#ifndef _DYNALOADER_H_
#define _DYNALOADER_H_


#include <dlfcn.h>
#include <stdlib.h>
#include "Error.h"
#include "mString.h"
#include "mListVal.h"

//
//  Note that the older, instance-based DynaLoader used by Intermezzo is
// below.  I decided to go with a DynaLoader class which provides only
// static wrappers around the dl() functions for Mercator.
//
//			-keith

class DynaLoader {
private:
    static mListVal<mString> searchPath;		
    DynaLoader();

public:
    typedef void *Handle;
    
    static Handle	Load(const char *objectFile=NULL, int mode=RTLD_LAZY);
    static int		Unload(Handle h);
    static Handle	Symbol(Handle h, const char *name);

    static void	        SearchPath(const mListVal<mString> &);
};

inline
DynaLoader::DynaLoader()
{
    Error(EL_ABORT, "DynaLoader::DynaLoader",
	  "Should never instantiate a DynaLoader.\n"
	  "\tThis is a nonrecoverable error as it indicates a ",
	  "programmer logic error.", NULL);
}

#endif /* _DYNALOADER_H_ */

