// -*-C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
//
//	Loadable module for Genovations Keypad.
//
//	keith edwards 11jul95
//

#ifndef _GENOVATIONS_H_
#define _GENOVATIONS_H_

#include "FDInterest.h"

class Genovations : public FDInterest {
private:
    int			fd;
    char		*device;

    typedef struct _KeyMapEntry {
	char		key;
	int		numLockState;
    } KeyMapEntry;

    // Beginning keycode is 65, last keycode is 121
    enum { KEYMAP_START = 65,
	   KEYMAP_MAX   = 121
    };
    
    static KeyMapEntry	keymap[KEYMAP_MAX - KEYMAP_START + 1];

    static int		OpenDevice(const char *devName);

    void		KeyPressed(char key, int numLockState = 0) const;
    
public:
    Genovations();
    virtual ~Genovations();
    
    virtual int		HandleActivity(int fd, short type);
    virtual void	Shutdown(int fd);
};

#endif /* _GENOVATIONS_H_ */
