//  -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
#ifndef __Interp_h__
#define __Interp_h__


//
// comments
//


//
// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/Interp.h,v $
// $Revision: 6.7 $
// $Date: 1995/10/15 16:38:03 $
/* $Log: Interp.h,v $
 * Revision 6.7  1995/10/15  16:38:03  spine
 * Added a file stream data member to point to the same output stream as outfd
 * so we can flush its output.
 *
 * Revision 6.6  1995/10/12  20:10:25  spine
 * Added Prompt and GetOutfd methods.
 *
 * Revision 6.5  1995/08/31  20:21:14  keith
 * Added modelManager {x, y, width, height} commands, cleaned up handling
 * of descriptor changes.
 *
 * Revision 6.4  1995/08/13  20:05:30  kchen
 * dummy log message for checkin
 *
 * Revision 6.3  1995/08/02  22:10:47  spine
 * Added functions to dis/connect console pipes.
 *
 * Revision 6.2  1995/08/02  03:38:37  spine
 * Added copyright.
 *
 * Revision 6.1  1995/07/01  20:03:30  spine
 * Removed all references to LEDA strings and LEDA.
 *
 * Revision 6.0  1995/05/20  22:20:21  beth
 * Mercator Version 6
 *
 * Revision 1.2  1995/03/06  17:51:28  keith
 * *** empty log message ***
 *
 * Revision 1.1  1994/11/16  20:46:23  spine
 * Initial revision
 *
 * Revision 1.1  1994/05/24  19:49:25  stacy
 * Initial revision
 *
 * Revision 1.3  1994/04/14  23:23:07  kathryn
 * *** empty log message ***
 *
 * Revision 1.2  1994/04/06  20:56:20  kathryn
 * *** empty log message ***
 *
 * Revision 1.1  1994/04/06  19:54:58  kathryn
 * Initial revision
 *
*/

#ident "$Id: Interp.h,v 6.7 1995/10/15 16:38:03 spine Exp $"


#include "FDInterest.h"
#include "mString.h"
#include "Mercator.h"


extern "C" {
#ifdef TCL7
#	include "mercator-tcl-sol.h"
#else
#	include "mercator-tcl.h"
#endif
}

class Interp : public FDInterest {
private:
    Tcl_Interp  	*interpreter;
    int          	infd;
    int          	outfd;
    static FILE         *outFile;
    
#ifdef TCL7
    Tcl_DString   	cmdbuf;
#else
    Tcl_CmdBuf    	cmdbuf;
#endif

public:
    Interp(int in, int out, Tcl_Interp *interp = NULL);
    virtual ~Interp();

    int 	SourceInitialTCLfile();
    int 	HandleActivity(int fd, short type);
    operator 	Tcl_Interp*();

    void 	SetDescriptors(int in, int out);
    int 	DisconnectPipe();
    int 	ConnectPipe();
    int         Prompt();
    int         GetOutfd();
};

inline Interp::operator Tcl_Interp*() { return interpreter; }

inline Interp::GetOutfd() {return outfd;}

#endif /* __Interp_h__ */
