// -*-Mode: C++-*-

#ifndef __LEDACompare_h__
#define __LEDACompare_h__


//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
// This are the functions required by LEDA
//


//
// $Author: beth $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/LEDACompare.h,v $
// $Revision: 6.0 $
// $Date: 1995/05/20 22:20:21 $
/* $Log: LEDACompare.h,v $
 * Revision 6.0  1995/05/20  22:20:21  beth
 * Mercator Version 6
 *
 * Revision 1.3  1995/04/01  19:40:38  keith
 * End of work by Keith
 *
 * Revision 1.2  1995/03/06  17:51:28  keith
 * *** empty log message ***
 *
 * Revision 1.1  1994/11/16  20:46:23  spine
 * Initial revision
 *
 * Revision 1.1  1994/05/24  19:49:25  stacy
 * Initial revision
 *
 * Revision 1.2  1994/04/06  20:56:20  kathryn
 * *** empty log message ***
 *
 * Revision 1.1  1994/04/06  19:55:56  kathryn
 * Initial revision
 *
*/

#ident "$Id: LEDACompare.h,v 6.0 1995/05/20 22:20:21 beth Exp $"

#include <string.h>
#include "Storage.h"

//
// Compare function for const char *'s
//
inline int
compare(const char *a, const char *b)
{
    return strcmp(a, b);
}

//
// compare function for LEDA for the EventPtr
//
inline int 
compare (EventPtr a, EventPtr b) 
{
    if (a->eventType != b->eventType)
	return (a->eventType - b->eventType);
    
    switch (a->eventType) {
    case KEYPRESS:
    case KEYRELEASE: 
	if (a->key != b->key)
	    return (a->key - b->key);
	if (a->modifier != b->modifier)
	    return (a->modifier - b->modifier);
	break;
    default: 
	return 1;
    }
    return 0; // still here -- a & b must be equal
}

//
// These are some primitives required for using unsigned longs with LEDA.
//
inline int compare(unsigned long &a, unsigned long &b) { return a - b; }
inline void Print(unsigned long&  x, ostream& out = cout)  { out << x; }
inline void Read(unsigned long&  x, istream& in = cin)   { in >> x; }
inline ent Inint(unsigned long&  x) { x=0; return ent(x); }
inline void Clear(unsigned long&  x) { x=0; }
inline ent Copy(const unsigned long&  x)  { return ent(x); }
inline ent Ent(unsigned long   x) { return (void*)(x); }

//
// And const char *'s
//
#if 0
inline void Print(const char*& x, ostream& out = cout)  { out << x; }
inline void Read(const char *& x, istream& in = cin)   { abort(); }
inline ent Init(const char *& x) { return ent(x); }
inline void Clear(const char *& x) { return; }
inline ent Copy(const char *& x)  { return ent(x); }
inline ent Ent(const char *& x) { return (void*)(x); }

inline void Print(const char*& x, ostream& out = cout)  { out << x; }
inline void Read(const char *& x, istream& in = cin)   { abort(); }
inline ent Init(const char *& x) { abort(); return ent(x); }
inline void Clear(const char *& x) { abort(); }
inline ent Copy(const char *& x)  { return ent(x); }
inline ent Ent(const char *& x) { return (void*)(x); }
#endif

#endif __LEDACompare_h__
