//  -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
//
// Loadable - Support for dynamically-loadable code modules.
//
//	keith edwards	11march95
//

#ifndef _LOADABLE_H_
#define _LOADABLE_H_

//
// Every loadable class must provide a non-mangled (i.e., C binding) routine
// to create an instance of that class via the default constructor.  The DEFN
// macro should be placed in the .cc file to create this entry point.
//
#define LOADABLE_CLASS_DEFN(className) \
	extern "C" { className *New##className()  { return new className(); } }


#endif /* _LOADABLE_H_ */
