//  -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//

#ifndef __NetAudio_h__
#define __NetAudio_h__

// 
// comments for class NetAudio
//
 
 
//
// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/NetAudio.h,v $
// $Revision: 6.5 $
// $Date: 1995/10/25 18:48:59 $
/* $Log: NetAudio.h,v $
 * Revision 6.5  1995/10/25  18:48:59  spine
 * Added a ShutDown method to prevent the object from trying to play sound
 * after the server has been killed. (It caused mercator to hang until the
 * client times out if the server has been killed.)
 *
 * Revision 6.4  1995/09/21  21:39:55  keith
 * Made a few cleanups, signal handling stuff...
 *
 * Revision 6.3  1995/09/19  21:40:43  spine
 * Added StartServer member.
 *
 * Revision 6.2  1995/08/17  20:34:37  spine
 * Added an api to connect to the audio server.
 *
 * Revision 6.1  1995/07/28  20:42:07  spine
 * Added copyright notice.
 *
 * Revision 6.0  1995/05/20  22:20:21  beth
 * Mercator Version 6
 *
 * Revision 1.3  1995/04/01  19:40:38  keith
 * End of work by Keith
 *
 * Revision 1.2  1995/03/06  17:51:28  keith
 * *** empty log message ***
 *
 * Revision 1.1  1994/11/16  20:46:23  spine
 * Initial revision
 *
 * Revision 1.1  1994/05/24  19:49:25  stacy
 * Initial revision
 *
 * Revision 1.2  1994/04/06  20:56:20  kathryn
 * *** empty log message ***
 *
 * Revision 1.1  1994/04/06  20:13:39  kathryn
 * Initial revision
 *
*/
 
#ident "$Id: NetAudio.h,v 6.5 1995/10/25 18:48:59 spine Exp $"

#include "Audio.h"

extern "C" {
#include <rpc/rpc.h>
#include <na.h>
}


class NetAudio : Audio {
private:
    AudioServer 		*audio_server;
    
public:
    NetAudio(const char *hostname = NULL);
    virtual ~NetAudio(void);

    virtual SoundID	PlaySound(const char *sound_file, float *rate, 
				  int volume, int muffle, int looped);
    virtual int		StopSound(Audio::SoundID);
    virtual int		StopAllSounds();

    virtual int         ConnectServer(const char *hostname);
    virtual int         StartServer();

    virtual void        ShutDown();
};

#endif /*__NetAudio_h__ */
