//  -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
#ifndef __TclAction_h__
#define __TclAction_h__


//  This is a subclass of the Action class that understand invoking
//  procedure in a Tcl interpreter.  TclActions are constructed by
//  passing in a pointer to a Tcl interpreter and a string to be
//  evaluated.  The string arguments that are passed to the Invoke
//  method and concatenated onto the string arg in the class and
//  evaluated in the interpreter.  No data is returned after the
//  evaluation.  Any error handling must be done within Tcl.
//
//  Changed to cooperate with the new Action stuff, 21jan95, -keith
//


//
// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/TclAction.h,v $
// $Revision: 6.2 $
// $Date: 1995/07/28 20:49:39 $
//

#ident "$Id: TclAction.h,v 6.2 1995/07/28 20:49:39 spine Exp $"


#include "Action.h"
extern "C" {
#ifdef TCL7
#include "mercator-tcl-sol.h"
#else
#include "mercator-tcl.h"
#endif
}

class TclAction : public Action {
private:
    Tcl_Interp 		*interpreter;

public:
    TclAction(Tcl_Interp *interp, const char *name);
    virtual ~TclAction(); 	// virtual function from Action

    // Inherited from Action
    virtual int 	Invoke(int argc, char *argv[],
			       const char **result = NULL);
};

#endif __TclAction_h__
