// -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
//
// Cheezy thread class just to make things a little more O-O
//

// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/Thread.cc,v $
// $Date: 1995/07/28 20:53:40 $
/* 
 * $Log: Thread.cc,v $
// Revision 1.2  1995/07/28  20:53:40  spine
// Added copyright notice.
//
// Revision 1.1  1995/07/25  23:02:26  spine
// Initial revision
//
 */

#include "Thread.h"

extern "C" {
#include "os-interface.h"
}
#include "Error.h"

void Thread::ThreadStarter(void *arg)
{
    Thread *self=(Thread *)arg;
    
    self->Initialize();
    self->Main();
    self->Finish();
}

void Thread::Start(ThreadPriority prio)
{
    switch (prio) {
      case HighPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_HIGH_PRIORITY);
	break;
      case MediumPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_MEDIUM_PRIORITY);
	break;
      case LowPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_LOW_PRIORITY);
	break;
      default:
	  Error(EL_ABORT,"Thread::Start","Default gets used!",NULL);
    }
}

Thread::Thread()
{
}

void Thread::Initialize()
{
    /* no default initialization */
}

void Thread::Finish()
{
    /* no default finish */
}

Thread::Thread(const Thread &t)
{
    /* this is not allowed */
    Error(EL_ABORT,"Thread::Thread","Thread copy constructor is not allowed!",NULL);
}

Thread & Thread::operator=(const Thread &)
{
    /* this is not allowed */
    Error(EL_ABORT,"Thread::operator=","operator =  is not allowed!",NULL);
    /* bogus to make compiler happy */
    return *this;
}

/* 
 * Just so subclassess don't need to do this...
 */
THREAD_T Thread::ThreadId() const
{
    return THREAD_self();
}

//
//
//      Copyright 1992, 1993, 1994, 1995
//      Georgia Tech Research Corporation
//      All rights reserved.
//
//
//
// Cheezy thread class just to make things a little more O-O
//

// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/Thread.cc,v $
// $Date: 1995/07/28 20:53:40 $
/* 
 * $Log: Thread.cc,v $
// Revision 1.2  1995/07/28  20:53:40  spine
// Added copyright notice.
//
// Revision 1.1  1995/07/25  23:02:26  spine
// Initial revision
//
 */

#include "Thread.h"

extern "C" {
#include "os-interface.h"
}
#include "Error.h"

void Thread::ThreadStarter(void *arg)
{
    Thread *self=(Thread *)arg;
    
    self->Initialize();
    self->Main();
    self->Finish();
}

void Thread::Start(ThreadPriority prio)
{
    switch (prio) {
      case HighPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_HIGH_PRIORITY);
	break;
      case MediumPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_MEDIUM_PRIORITY);
	break;
      case LowPriority:
	tid=THREAD_fork(ThreadStarter,this,THREAD_LOW_PRIORITY);
	break;
      default:
	  Error(EL_ABORT,"Thread::Start","Default gets used!",NULL);
    }
}

Thread::Thread()
{
}

void Thread::Initialize()
{
    /* no default initialization */
}

void Thread::Finish()
{
    /* no default finish */
}

Thread::Thread(const Thread &t)
{
    /* this is not allowed */
    Error(EL_ABORT,"Thread::Thread","Thread copy constructor is not allowed!",NULL);
}

Thread & Thread::operator=(const Thread &)
{
    /* this is not allowed */
    Error(EL_ABORT,"Thread::operator=","operator =  is not allowed!",NULL);
    /* bogus to make compiler happy */
    return *this;
}

/* 
 * Just so subclassess don't need to do this...
 */
THREAD_T Thread::ThreadId() const
{
    return THREAD_self();
}

