// -*-Mode: C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
// This is my implementation of the generic audio interface for the
// AudioFIle subsystem. 
//

// $Author: spine $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/Thread.h,v $
// $Date: 1995/07/28 20:54:03 $
/* 
 * $Log: Thread.h,v $
 * Revision 1.2  1995/07/28  20:54:03  spine
 * Added copyright notice.
 *
 * Revision 1.1  1995/07/25  23:01:46  spine
 * Initial revision
 *
 */

#ifndef _MERC_THREAD_H_
#define _MERC_THREAD_H_

extern "C" {
#include "os-interface.h"
}

class Thread {
    static void ThreadStarter(void *);
    // These are private to disallow these calls
    Thread(const Thread &);
    Thread & operator=(const Thread &);
    THREAD_T tid;
public:
    typedef enum  { HighPriority, MediumPriority, LowPriority} ThreadPriority;
    Thread();
    virtual void Initialize();
    virtual void Main()=0;
    virtual void Finish();
    void Start(ThreadPriority prio=MediumPriority);
    THREAD_T ThreadId() const;
};

#endif /* MERC_THREAD_H */
