
%{
/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/

#include <string.h>
int line_number = 1;
int field_number = 0;
%}



%%

[ \t]+	;

#.*	;


\n	{
	  if ((field_number != 4) && (field_number != 0))
	    printf("Suspicious looking line: %d - there appears to be %d fields\n", line_number, field_number);
	  line_number++;
	  field_number = 0;
	}


CLASS		{
		  field_number++;
		  return (yylval.integer = CLASS);
		}

APP		{
		  field_number++;
		  return (yylval.integer = APP);
		}

INTEGER		{
		  field_number++;
		  return (yylval.integer = INTEGER);
		}

STRING		{
		  field_number++;
		  return (yylval.integer = STRING);
		}

STRINGLIST	{
		  field_number++;
		  return (yylval.integer = STRINGLIST);
		}

BOOLEAN		{
		  field_number++;
		  return (yylval.integer = BOOLEAN);
		}


[a-zA-Z][a-zA-Z0-9_\-\.]*	{
				  field_number++;

				  yylval.identifier = strdup(yytext); 
				  return IDENTIFIER;
				}

.	{
	  yylval.integer = (int)(yytext[0]);
	  return (int)(yytext[0]);
	}



%%

