%{

/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
    
extern void ProcessAttributeLine(char *name, int ftype, char *defaultname,
                                 int cltype);

extern int yylineno;
extern char yytext[];

%}

%union {
    long        integer;        /* integer return */
    char        *identifier;    /* identifier return */
}



%token <identifier> IDENTIFIER

/* these match the enumerated type defintions in the c++ code */
%token <integer> BOOLEAN 0 INTEGER 1 STRING 2 STRINGLIST 3 
%token <integer> CLASS 1 APP 2

%type <integer> fieldtype
%type <integer> classtype

%%

file:	lines

/* lines:	line | line lines */
lines:	  /* empty */
	| lines line
	;

line:	IDENTIFIER fieldtype IDENTIFIER classtype
	{ProcessAttributeLine($1, $2, $3, $4);}

fieldtype:	STRING | STRINGLIST | BOOLEAN | INTEGER

classtype:	APP | CLASS

%%

#include "attriblexer.c"

static int
yywrap()
{
    return 1;
}



static int
yyerror(char *str)
{
    printf("yyerror: line: %d      %s  at  %s\n", yylineno, str, yytext);
    return 1;
}

