
/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
    
extern int configLineno;

typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
    long	integer;	/* integer return */
    char	*string;	/* string return */
    char	*identifier;	/* identifier return */
    unsigned char bool;		/* boolean return */
} YYSTYPE;
# define INTEGER 257
# define STRING 258
# define IDENTIFIER 259
# define BOOLEAN 260

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef configerror
	void configerror(const char *);
#endif

#ifndef configlex
#ifdef __EXTERN_C__
	extern "C" { int configlex(void); }
#else
	int configlex(void);
#endif
#endif
	int configparse(void);

#endif
#define configclearin configchar = -1
#define configerrok configerrflag = 0
extern int configchar;
extern int configerrflag;
YYSTYPE configlval;
YYSTYPE configval;
typedef int configtabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int config_configs[YYMAXDEPTH], *configs = config_configs;
YYSTYPE config_configv[YYMAXDEPTH], *configv = config_configv;
#else	/* user does initial allocation */
int *configs;
YYSTYPE *configv;
#endif
static int configmaxdepth = YYMAXDEPTH;
# define YYERRCODE 256


#include "configlexer.c"

int
configwrap()
{
    return 1;
}

static int
configerror(char *str)
{
    char tmp[16];
    sprintf(tmp, "%d", configLineno);
    fprintf(stderr, "configerror: line %s: %s\n", tmp, str);
    return 1;
}
configtabelem configexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 13
# define YYLAST 222
configtabelem configact[]={

    10,    15,     4,    19,    13,    18,     5,    16,     3,     2,
    17,     1,    12,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    11,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     7,     8,     9,
     6,    14 };
configtabelem configpact[]={

-10000000,-10000000,  -257,-10000000,   -55,   -40,-10000000,-10000000,-10000000,-10000000,
   -37,  -258,   -34,-10000000,-10000000,   -88,-10000000,  -255,-10000000,-10000000 };
configtabelem configpgo[]={

     0,    12,    11,     9,     8 };
configtabelem configr1[]={

     0,     2,     3,     3,     4,     4,     4,     4,     4,     4,
     4,     1,     1 };
configtabelem configr2[]={

     0,     2,     0,     4,     7,     7,     7,     7,    11,     9,
    11,     7,     3 };
configtabelem configchk[]={

-10000000,    -2,    -3,    -4,   259,    61,   260,   257,   258,   259,
    40,    91,    -1,    41,   258,   259,    41,    44,    93,   258 };
configtabelem configdef[]={

     2,    -2,     1,     3,     0,     0,     4,     5,     6,     7,
     0,     0,     0,     9,    12,     0,     8,     0,    10,    11 };
typedef struct
#ifdef __cplusplus
	configtoktype
#endif
{ char *t_name; int t_val; } configtoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

configtoktype configtoks[] =
{
	"INTEGER",	257,
	"STRING",	258,
	"IDENTIFIER",	259,
	"BOOLEAN",	260,
	"-unknown-",	-1	/* ends search */
};

char * configreds[] =
{
	"-no such reduction-",
	"start : lines",
	"lines : /* empty */",
	"lines : lines line",
	"line : IDENTIFIER '=' BOOLEAN",
	"line : IDENTIFIER '=' INTEGER",
	"line : IDENTIFIER '=' STRING",
	"line : IDENTIFIER '=' IDENTIFIER",
	"line : IDENTIFIER '=' '(' stringlist ')'",
	"line : IDENTIFIER '=' '(' ')'",
	"line : IDENTIFIER '=' '[' IDENTIFIER ']'",
	"stringlist : stringlist ',' STRING",
	"stringlist : STRING",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto configerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( configchar >= 0 || ( configr2[ configtmp ] >> 1 ) != 1 )\
	{\
		configerror( "syntax error - cannot backup" );\
		goto configerrlab;\
	}\
	configchar = newtoken;\
	configstate = *configps;\
	configlval = newvalue;\
	goto confignewstate;\
}
#define YYRECOVERING()	(!!configerrflag)
#define YYNEW(type)	malloc(sizeof(type) * confignewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, confignewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, confignewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int configdebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *configpv;			/* top of value stack */
int *configps;			/* top of state stack */

int configstate;			/* current state */
int configtmp;			/* extra var (lasts between blocks) */

int confignerrs;			/* number of errors */
int configerrflag;			/* error recovery flag */
int configchar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		configcvtok(configlex())
/*
** configcvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int configcvtok(int i)
#else
int configcvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( configmbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = configmbchars[mid].character;
			if( j==i ){/*Found*/ 
				return configmbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		configlex()
#endif/*!YYNMBCHARS*/

/*
** configparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int configparse(void)
#else
int configparse()
#endif
{
	register YYSTYPE *configpvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; configpvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto configerrlab;
		case 2: goto confignewstate;
	}
	configpvt = 0;
#endif

	/*
	** Initialize externals - configparse may be called more than once
	*/
	configpv = &configv[-1];
	configps = &configs[-1];
	configstate = 0;
	configtmp = 0;
	confignerrs = 0;
	configerrflag = 0;
	configchar = -1;

#if YYMAXDEPTH <= 0
	if (configmaxdepth <= 0)
	{
		if ((configmaxdepth = YYEXPAND(0)) <= 0)
		{
			configerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *config_pv;	/* top of value stack */
		register int *config_ps;		/* top of state stack */
		register int config_state;		/* current state */
		register int  config_n;		/* internal state number info */
	goto configstack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	confignewstate:
		config_pv = configpv;
		config_ps = configps;
		config_state = configstate;
		goto config_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	configstack:
		config_pv = configpv;
		config_ps = configps;
		config_state = configstate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	config_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( configdebug )
		{
			register int config_i;

			printf( "State %d, token ", config_state );
			if ( configchar == 0 )
				printf( "end-of-file\n" );
			else if ( configchar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( config_i = 0; configtoks[config_i].t_val >= 0;
					config_i++ )
				{
					if ( configtoks[config_i].t_val == configchar )
						break;
				}
				printf( "%s\n", configtoks[config_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++config_ps >= &configs[ configmaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int configps_index = (config_ps - configs);
			int configpv_index = (config_pv - configv);
			int configpvt_index = (configpvt - configv);
			int confignewmax;
#ifdef YYEXPAND
			confignewmax = YYEXPAND(configmaxdepth);
#else
			confignewmax = 2 * configmaxdepth;	/* double table size */
			if (configmaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newconfigs = (char *)YYNEW(int);
				char *newconfigv = (char *)YYNEW(YYSTYPE);
				if (newconfigs != 0 && newconfigv != 0)
				{
					configs = YYCOPY(newconfigs, configs, int);
					configv = YYCOPY(newconfigv, configv, YYSTYPE);
				}
				else
					confignewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				configs = YYENLARGE(configs, int);
				configv = YYENLARGE(configv, YYSTYPE);
				if (configs == 0 || configv == 0)
					confignewmax = 0;	/* failed */
			}
#endif
			if (confignewmax <= configmaxdepth)	/* tables not expanded */
			{
				configerror( "yacc stack overflow" );
				YYABORT;
			}
			configmaxdepth = confignewmax;

			config_ps = configs + configps_index;
			config_pv = configv + configpv_index;
			configpvt = configv + configpvt_index;
		}
		*config_ps = config_state;
		*++config_pv = configval;

		/*
		** we have a new state - find out what to do
		*/
	config_newstate:
		if ( ( config_n = configpact[ config_state ] ) <= YYFLAG )
			goto configdefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		configtmp = configchar < 0;
#endif
		if ( ( configchar < 0 ) && ( ( configchar = YYLEX() ) < 0 ) )
			configchar = 0;		/* reached EOF */
#if YYDEBUG
		if ( configdebug && configtmp )
		{
			register int config_i;

			printf( "Received token " );
			if ( configchar == 0 )
				printf( "end-of-file\n" );
			else if ( configchar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( config_i = 0; configtoks[config_i].t_val >= 0;
					config_i++ )
				{
					if ( configtoks[config_i].t_val == configchar )
						break;
				}
				printf( "%s\n", configtoks[config_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( config_n += configchar ) < 0 ) || ( config_n >= YYLAST ) )
			goto configdefault;
		if ( configchk[ config_n = configact[ config_n ] ] == configchar )	/*valid shift*/
		{
			configchar = -1;
			configval = configlval;
			config_state = config_n;
			if ( configerrflag > 0 )
				configerrflag--;
			goto config_stack;
		}

	configdefault:
		if ( ( config_n = configdef[ config_state ] ) == -2 )
		{
#if YYDEBUG
			configtmp = configchar < 0;
#endif
			if ( ( configchar < 0 ) && ( ( configchar = YYLEX() ) < 0 ) )
				configchar = 0;		/* reached EOF */
#if YYDEBUG
			if ( configdebug && configtmp )
			{
				register int config_i;

				printf( "Received token " );
				if ( configchar == 0 )
					printf( "end-of-file\n" );
				else if ( configchar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( config_i = 0;
						configtoks[config_i].t_val >= 0;
						config_i++ )
					{
						if ( configtoks[config_i].t_val
							== configchar )
						{
							break;
						}
					}
					printf( "%s\n", configtoks[config_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *configxi = configexca;

				while ( ( *configxi != -1 ) ||
					( configxi[1] != config_state ) )
				{
					configxi += 2;
				}
				while ( ( *(configxi += 2) >= 0 ) &&
					( *configxi != configchar ) )
					;
				if ( ( config_n = configxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( config_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( configerrflag )
			{
			case 0:		/* new error */
				configerror( "syntax error" );
				goto skip_init;
			configerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				config_pv = configpv;
				config_ps = configps;
				config_state = configstate;
			skip_init:
				confignerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				configerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( config_ps >= configs )
				{
					config_n = configpact[ *config_ps ] + YYERRCODE;
					if ( config_n >= 0 && config_n < YYLAST &&
						configchk[configact[config_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						config_state = configact[ config_n ];
						goto config_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( configdebug )
						printf( _POP_, *config_ps,
							config_ps[-1] );
#	undef _POP_
#endif
					config_ps--;
					config_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( configdebug )
				{
					register int config_i;

					printf( "Error recovery discards " );
					if ( configchar == 0 )
						printf( "token end-of-file\n" );
					else if ( configchar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( config_i = 0;
							configtoks[config_i].t_val >= 0;
							config_i++ )
						{
							if ( configtoks[config_i].t_val
								== configchar )
							{
								break;
							}
						}
						printf( "token %s\n",
							configtoks[config_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( configchar == 0 )	/* reached EOF. quit */
					YYABORT;
				configchar = -1;
				goto config_newstate;
			}
		}/* end if ( config_n == 0 ) */
		/*
		** reduction by production config_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( configdebug )
			printf( "Reduce by (%d) \"%s\"\n",
				config_n, configreds[ config_n ] );
#endif
		configtmp = config_n;			/* value to switch over */
		configpvt = config_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using config_state here as temporary
		** register variable, but why not, if it works...
		** If configr2[ config_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto config_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int config_len = configr2[ config_n ];

			if ( !( config_len & 01 ) )
			{
				config_len >>= 1;
				configval = ( config_pv -= config_len )[1];	/* $$ = $1 */
				config_state = configpgo[ config_n = configr1[ config_n ] ] +
					*( config_ps -= config_len ) + 1;
				if ( config_state >= YYLAST ||
					configchk[ config_state =
					configact[ config_state ] ] != -config_n )
				{
					config_state = configact[ configpgo[ config_n ] ];
				}
				goto config_stack;
			}
			config_len >>= 1;
			configval = ( config_pv -= config_len )[1];	/* $$ = $1 */
			config_state = configpgo[ config_n = configr1[ config_n ] ] +
				*( config_ps -= config_len ) + 1;
			if ( config_state >= YYLAST ||
				configchk[ config_state = configact[ config_state ] ] != -config_n )
			{
				config_state = configact[ configpgo[ config_n ] ];
			}
		}
					/* save until reenter driver code */
		configstate = config_state;
		configps = config_ps;
		configpv = config_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( configtmp )
	{
		
case 4:{ ProcessBooleanDecl(configLineno, configpvt[-2].identifier, configpvt[-0].bool); free(configpvt[-2].identifier); } break;
case 5:{ ProcessIntegerDecl(configLineno, configpvt[-2].identifier, configpvt[-0].integer); free(configpvt[-2].identifier); } break;
case 6:{ ProcessStringDecl(configLineno, configpvt[-2].identifier, configpvt[-0].string); free(configpvt[-2].identifier); free(configpvt[-0].string); } break;
case 7:{ ProcessIdentifierDecl(configLineno, configpvt[-2].identifier, configpvt[-0].identifier); free(configpvt[-2].identifier); free(configpvt[-0].identifier); } break;
case 8:{ ProcessStringListDecl(configLineno, configpvt[-4].identifier); free(configpvt[-4].identifier); } break;
case 9:{ ProcessStringListDecl(configLineno, configpvt[-3].identifier); free(configpvt[-3].identifier); } break;
case 10:{ ProcessProcDecl(configLineno, configpvt[-4].identifier, configpvt[-1].identifier); free(configpvt[-4].identifier); free(configpvt[-1].identifier); } break;
case 11:{ ConfigAddToStringList(configLineno, configpvt[-0].string); free(configpvt[-0].string); } break;
case 12:{ ConfigAddToStringList(configLineno, configpvt[-0].string); free(configpvt[-0].string); } break;
	}
	goto configstack;		/* reset registers in driver code */
}

