// This may look like C code, but it is really -*- C++ -*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
#ifndef M_REGEXP_H
#define M_REGEXP_H

#include <rw/regexp.h>
#include "mString.h"

class mRegexpError {
public:
  int error; // I don't use this, but I figured I'd put in in for fun.
};

class mRegexp {
private:
  RWCRegexp impl;

public:
  friend class mString;

  mRegexp(void);
  mRegexp(const char *pattern);
  mRegexp(const mRegexp &r);
  ~mRegexp();

  mRegexp& operator=(const mRegexp& r);
  mRegexp& operator=(const char *pattern);

  // This is a bit hackish.  According to the user manual, this should take
  //   mString&, int *, int, but the compiler sez it's expecting
  //   mString&, unsigned *, unsigned.  Actually, the header sez it should
  //   take mString&, size_t *, size_t, but I have no idea where site_t is
  //   declared.  If someone figures this out, they ought to change the
  //   prototype to fix this.
  int index(const mString& str, unsigned int *len,
	    unsigned int start = 0) const;
};

#endif /* MREGEXP_H */
