//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//

#include "mRegexp.h"
#include "mString.h"

mString::mString() : impl() { }
mString::mString(const char *c) : impl(c) { }
mString::mString(const char *c, int n) : impl(c, n) {}
mString::mString(const mString& m) : impl(m.impl) { }

mString::operator char *() const { return Strdup(impl); }
mString::operator const char *() const { return impl; }

mString& mString::operator=(const mString& m) {
  impl = m.impl; return *this;
}

mString& mString::operator+=(const mString &m) {
  impl += m.impl; return *this;
}

mString& mString::operator+=(const char *c) {
  impl += mString(c); return *this;
}

unsigned mString::hash() const { 
  return impl.hash(); 
}

unsigned mString::length() const { 
  return impl.length(); 
}

int mString::operator==(const mString& m) const {
  return impl == m.impl;
}

int mString::operator<(const mString& m) const {
  return impl < m.impl;
}

int mString::index(const char *c, int i) const {
  return impl.index(c, i);
}

int mString::index(const mString &m, int i) const {
  return impl.index(m.impl, i);
}

int mString::index(const mRegexp &r, int i) const {
  return impl.index(r.impl, i);
}

int mString::index(const mRegexp &r, unsigned int *len, 
			  unsigned int i) const {
  return impl.index(r.impl, len, i);
}

int mString::insert(int i, const char *c) {
  if (impl(i,0).isNull())
    return 0;
  impl(i, 0) = c;
  return 1;
}

int mString::insert(int i, mString& m) {
  if (impl(i,0).isNull())
    return 0;
  impl(i, 0) = m;
  return 1;
}

int mString::subst(mRegexp &r, int i, mString &m) {
  int j;
  if ((j = impl.index(r.impl, i)) >= 0) {
    impl(r.impl, i) = m.impl;
    return j + strlen((const char *)m.impl);
  }
  else
    return -1;
}

int mString::subst(mRegexp &r, int i, const char *c) {
  int j;
  if ((j = impl.index(r.impl, i)) >= 0) {
    impl(r.impl, i) = c;
    return j + strlen(c);
  }
  else
    return -1;
}

mString* mString::substString(mRegexp &r, int i) {
  mString *ret = new mString();
  ret->impl = impl(r.impl, i); return ret;
}

void mString::replace(int i, int len, mString& m) {
  impl(i, len) = m.impl; 
}

void mString::replace(int i, int len, const char *c) {
  impl(i, len) = c;
}
