// -*-Mode:C++-*-
//
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
//
// The main for the Mercator project
// This basically starts up everything and lets them wait
// for input from the desired applications. 
// 

//
// $Author: keith $
// $Source: /net/hm10/keith/proj/mercator/6.0/RCS/mercator.cc,v $
// $Revision: 6.25 $
// $Date: 1995/12/03 01:47:04 $
//

static const char rcsid[]="@(#) $Header: /net/hm10/keith/proj/mercator/6.0/RCS/mercator.cc,v 6.25 1995/12/03 01:47:04 keith Exp $";


#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <fstream.h>
#include "Mercator.h"
#include "FDInterest.h"
#include "Error.h"
#include "Config.h"
#include "XServer.h"
#include "Interp.h"
#include "Template.h"
#include "Attribute.h"
#include "mListVal.h"
#include "Audio.h"
#include "Braille.h"
#include "Speech.h"


/////
/////	Here is the one, almighty Mercator instance.  Yes, it is
/////	global.
/////
Mercator *mercator = NULL;

int
main(int argc, char *argv[], char *envp[])
{
    
    cout << "\n\tCopyright 1992, 1993, 1994, 1995, 1996\n";
    cout << "\tGeorgia Tech Research Corporation\n";
    cout << "\tAll rights reserved.\n\n";

    cout << "\n\tNote:  The use of this program shall be restricted to educational,\n";
    cout << "non-commercial use only.  All inquiries regarding licensing this\n";
    cout << "software for commercial use may be addressed to:\n";
    cout << "\n\tGeorgia Tech Research Corporation\n";
    cout << "\tTechnology Licensing\n";
    cout << "\tCentennial Research Building - Rm. 275\n";
    cout << "\t400 Tenth Street, N.W.\n";
    cout << "\tAtlanta, Georgia  30332-0415\n";

    mercator = new Mercator();

    mercator->InstallSignalHandlers();
    mercator->ProcessEnvVariables();

    if (!mercator->ProcessArgs(argc, argv))
	Error(EL_FATAL, argv[0], "Cannot continue.", NULL);

    /* attribute file must load before config file */
    if (!mercator->ParseAttribFile())
        Error(EL_ERROR, argv[0], "Error parsing attribute file: ",
	      mercator->AttribFilename(),  NULL);

    if (!mercator->ParseConfigFile())
	Error(EL_ERROR, argv[0], "Error parsing configuration file: ",
	      mercator->ConfigFilename(), ".", NULL);
    
    mercator->ProcessDefaults();
    mercator->GetInterp()->SourceInitialTCLfile();
    
    // Load our templates.
    if (!mercator->LoadTemplates())
	Error(EL_ERROR, argv[0], "Error while loading templates.", NULL);
    // Load definitions for ScreenReader filters
    mercator->LoadFilterDictionary();

    mercator->StartConsole();

    mercator->DumpMsg();
    
    FDInterest::MainLoop();

    // Free up our filters, template, config, and attribute information.
    mercator->FreeFilters();
    mercator->FreeTemplates();
    mercator->FreeConfig();
    mercator->FreeAttrib();

    // Clean up.
    delete mercator;
  
    return 0;
}
