/*
//
//
//	Note:  The use of this program shall be restricted to educational,
//	non-commercial use only.  All inquiries regarding licensing this
//	software for commercial use may be addressed to:
//	
//	Georgia Tech Research Corporation
//	Technology Licensing
//	Centennial Research Building - Rm. 275
//	400 Tenth Street, N.W.
//	Atlanta, Georgia  30332-0415
//	
//	*************************************************
//	
//	       Copyright 1996
//	Georgia Tech Research Corporation
//	    All Rights Reserved
//
//
//
*/
extern int templateLineno;
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
    char	dummy;		/* for tokens that return no value */
    long	integer;	/* integer return */
    char	*string;	/* string return */
    char	*identifier;	/* identifier return */
    unsigned char bool;		/* boolean return */
} YYSTYPE;
# define INTEGER 257
# define STRING 258
# define IDENTIFIER 259
# define BOOLEAN 260
# define OBJ_TEMPLATE 261
# define CLASS_TEMPLATE 262
# define APP_TEMPLATE 263
# define NEWLINE 264

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#else
#include <malloc.h>
#include <memory.h>
#endif

#include <values.h>

#ifdef __cplusplus

#ifndef tmplerror
	void tmplerror(const char *);
#endif

#ifndef tmpllex
#ifdef __EXTERN_C__
	extern "C" { int tmpllex(void); }
#else
	int tmpllex(void);
#endif
#endif
	int tmplparse(void);

#endif
#define tmplclearin tmplchar = -1
#define tmplerrok tmplerrflag = 0
extern int tmplchar;
extern int tmplerrflag;
YYSTYPE tmpllval;
YYSTYPE tmplval;
typedef int tmpltabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int tmpl_tmpls[YYMAXDEPTH], *tmpls = tmpl_tmpls;
YYSTYPE tmpl_tmplv[YYMAXDEPTH], *tmplv = tmpl_tmplv;
#else	/* user does initial allocation */
int *tmpls;
YYSTYPE *tmplv;
#endif
static int tmplmaxdepth = YYMAXDEPTH;
# define YYERRCODE 256


#include "tmpllexer.c"

/*
 * Replacements for tmplwrap and tmplerror.  These keep us from having to link
 * with libraries we really don't need.
 */

int
tmplwrap()
{
    return 1;
}

static int
tmplerror(char *str)
{
    fprintf(stderr, "tmplerror: %s\n", str);
    return 1;
}
tmpltabelem tmplexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 19
# define YYLAST 225
tmpltabelem tmplact[]={

     5,     6,     7,    21,    14,    26,    12,    24,    11,    10,
    30,     9,    29,    17,    27,    15,    13,    28,     8,     4,
     3,     2,     1,    23,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    16,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    19,    20,     0,    18,    25 };
tmpltabelem tmplpact[]={

-10000000,-10000000,  -261,-10000000,  -112,  -250,  -251,  -253,-10000000,-10000000,
-10000000,-10000000,-10000000,  -121,-10000000,-10000000,   -48,   -37,-10000000,-10000000,
-10000000,   -34,  -254,   -27,-10000000,-10000000,   -81,-10000000,  -248,-10000000,
-10000000 };
tmpltabelem tmplpgo[]={

     0,    23,    22,    21,    20,    19,    18,    16,    15 };
tmpltabelem tmplr1[]={

     0,     2,     3,     3,     4,     5,     5,     5,     6,     7,
     7,     8,     8,     8,     8,     8,     8,     1,     1 };
tmpltabelem tmplr2[]={

     0,     2,     0,     4,     5,     5,     5,     5,     6,     0,
     4,     7,     7,     7,    11,     9,    11,     7,     3 };
tmpltabelem tmplchk[]={

-10000000,    -2,    -3,    -4,    -5,   261,   262,   263,    -6,   123,
   259,   259,   259,    -7,   125,    -8,   259,    61,   260,   257,
   258,    40,    91,    -1,    41,   258,   259,    41,    44,    93,
   258 };
tmpltabelem tmpldef[]={

     2,    -2,     1,     3,     0,     0,     0,     0,     4,     9,
     5,     6,     7,     0,     8,    10,     0,     0,    11,    12,
    13,     0,     0,     0,    15,    18,     0,    14,     0,    16,
    17 };
typedef struct
#ifdef __cplusplus
	tmpltoktype
#endif
{ char *t_name; int t_val; } tmpltoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

tmpltoktype tmpltoks[] =
{
	"INTEGER",	257,
	"STRING",	258,
	"IDENTIFIER",	259,
	"BOOLEAN",	260,
	"OBJ_TEMPLATE",	261,
	"CLASS_TEMPLATE",	262,
	"APP_TEMPLATE",	263,
	"NEWLINE",	264,
	"-unknown-",	-1	/* ends search */
};

char * tmplreds[] =
{
	"-no such reduction-",
	"start : templates",
	"templates : /* empty */",
	"templates : templates template",
	"template : template_hdr template_body",
	"template_hdr : OBJ_TEMPLATE IDENTIFIER",
	"template_hdr : CLASS_TEMPLATE IDENTIFIER",
	"template_hdr : APP_TEMPLATE IDENTIFIER",
	"template_body : '{' fields '}'",
	"fields : /* empty */",
	"fields : fields field",
	"field : IDENTIFIER '=' BOOLEAN",
	"field : IDENTIFIER '=' INTEGER",
	"field : IDENTIFIER '=' STRING",
	"field : IDENTIFIER '=' '(' stringlist ')'",
	"field : IDENTIFIER '=' '(' ')'",
	"field : IDENTIFIER '=' '[' IDENTIFIER ']'",
	"stringlist : stringlist ',' STRING",
	"stringlist : STRING",
};
#endif /* YYDEBUG */
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.12	93/06/07 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto tmplerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( tmplchar >= 0 || ( tmplr2[ tmpltmp ] >> 1 ) != 1 )\
	{\
		tmplerror( "syntax error - cannot backup" );\
		goto tmplerrlab;\
	}\
	tmplchar = newtoken;\
	tmplstate = *tmplps;\
	tmpllval = newvalue;\
	goto tmplnewstate;\
}
#define YYRECOVERING()	(!!tmplerrflag)
#define YYNEW(type)	malloc(sizeof(type) * tmplnewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, tmplnewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, tmplnewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int tmpldebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *tmplpv;			/* top of value stack */
int *tmplps;			/* top of state stack */

int tmplstate;			/* current state */
int tmpltmp;			/* extra var (lasts between blocks) */

int tmplnerrs;			/* number of errors */
int tmplerrflag;			/* error recovery flag */
int tmplchar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		tmplcvtok(tmpllex())
/*
** tmplcvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int tmplcvtok(int i)
#else
int tmplcvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( tmplmbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = tmplmbchars[mid].character;
			if( j==i ){/*Found*/ 
				return tmplmbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		tmpllex()
#endif/*!YYNMBCHARS*/

/*
** tmplparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int tmplparse(void)
#else
int tmplparse()
#endif
{
	register YYSTYPE *tmplpvt;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside switch should never be
	executed; tmplpvt is set to 0 to avoid "used before set" warning.
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto tmplerrlab;
		case 2: goto tmplnewstate;
	}
	tmplpvt = 0;
#endif

	/*
	** Initialize externals - tmplparse may be called more than once
	*/
	tmplpv = &tmplv[-1];
	tmplps = &tmpls[-1];
	tmplstate = 0;
	tmpltmp = 0;
	tmplnerrs = 0;
	tmplerrflag = 0;
	tmplchar = -1;

#if YYMAXDEPTH <= 0
	if (tmplmaxdepth <= 0)
	{
		if ((tmplmaxdepth = YYEXPAND(0)) <= 0)
		{
			tmplerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *tmpl_pv;	/* top of value stack */
		register int *tmpl_ps;		/* top of state stack */
		register int tmpl_state;		/* current state */
		register int  tmpl_n;		/* internal state number info */
	goto tmplstack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	tmplnewstate:
		tmpl_pv = tmplpv;
		tmpl_ps = tmplps;
		tmpl_state = tmplstate;
		goto tmpl_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	tmplstack:
		tmpl_pv = tmplpv;
		tmpl_ps = tmplps;
		tmpl_state = tmplstate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	tmpl_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( tmpldebug )
		{
			register int tmpl_i;

			printf( "State %d, token ", tmpl_state );
			if ( tmplchar == 0 )
				printf( "end-of-file\n" );
			else if ( tmplchar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( tmpl_i = 0; tmpltoks[tmpl_i].t_val >= 0;
					tmpl_i++ )
				{
					if ( tmpltoks[tmpl_i].t_val == tmplchar )
						break;
				}
				printf( "%s\n", tmpltoks[tmpl_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++tmpl_ps >= &tmpls[ tmplmaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int tmplps_index = (tmpl_ps - tmpls);
			int tmplpv_index = (tmpl_pv - tmplv);
			int tmplpvt_index = (tmplpvt - tmplv);
			int tmplnewmax;
#ifdef YYEXPAND
			tmplnewmax = YYEXPAND(tmplmaxdepth);
#else
			tmplnewmax = 2 * tmplmaxdepth;	/* double table size */
			if (tmplmaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newtmpls = (char *)YYNEW(int);
				char *newtmplv = (char *)YYNEW(YYSTYPE);
				if (newtmpls != 0 && newtmplv != 0)
				{
					tmpls = YYCOPY(newtmpls, tmpls, int);
					tmplv = YYCOPY(newtmplv, tmplv, YYSTYPE);
				}
				else
					tmplnewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				tmpls = YYENLARGE(tmpls, int);
				tmplv = YYENLARGE(tmplv, YYSTYPE);
				if (tmpls == 0 || tmplv == 0)
					tmplnewmax = 0;	/* failed */
			}
#endif
			if (tmplnewmax <= tmplmaxdepth)	/* tables not expanded */
			{
				tmplerror( "yacc stack overflow" );
				YYABORT;
			}
			tmplmaxdepth = tmplnewmax;

			tmpl_ps = tmpls + tmplps_index;
			tmpl_pv = tmplv + tmplpv_index;
			tmplpvt = tmplv + tmplpvt_index;
		}
		*tmpl_ps = tmpl_state;
		*++tmpl_pv = tmplval;

		/*
		** we have a new state - find out what to do
		*/
	tmpl_newstate:
		if ( ( tmpl_n = tmplpact[ tmpl_state ] ) <= YYFLAG )
			goto tmpldefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		tmpltmp = tmplchar < 0;
#endif
		if ( ( tmplchar < 0 ) && ( ( tmplchar = YYLEX() ) < 0 ) )
			tmplchar = 0;		/* reached EOF */
#if YYDEBUG
		if ( tmpldebug && tmpltmp )
		{
			register int tmpl_i;

			printf( "Received token " );
			if ( tmplchar == 0 )
				printf( "end-of-file\n" );
			else if ( tmplchar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( tmpl_i = 0; tmpltoks[tmpl_i].t_val >= 0;
					tmpl_i++ )
				{
					if ( tmpltoks[tmpl_i].t_val == tmplchar )
						break;
				}
				printf( "%s\n", tmpltoks[tmpl_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( tmpl_n += tmplchar ) < 0 ) || ( tmpl_n >= YYLAST ) )
			goto tmpldefault;
		if ( tmplchk[ tmpl_n = tmplact[ tmpl_n ] ] == tmplchar )	/*valid shift*/
		{
			tmplchar = -1;
			tmplval = tmpllval;
			tmpl_state = tmpl_n;
			if ( tmplerrflag > 0 )
				tmplerrflag--;
			goto tmpl_stack;
		}

	tmpldefault:
		if ( ( tmpl_n = tmpldef[ tmpl_state ] ) == -2 )
		{
#if YYDEBUG
			tmpltmp = tmplchar < 0;
#endif
			if ( ( tmplchar < 0 ) && ( ( tmplchar = YYLEX() ) < 0 ) )
				tmplchar = 0;		/* reached EOF */
#if YYDEBUG
			if ( tmpldebug && tmpltmp )
			{
				register int tmpl_i;

				printf( "Received token " );
				if ( tmplchar == 0 )
					printf( "end-of-file\n" );
				else if ( tmplchar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( tmpl_i = 0;
						tmpltoks[tmpl_i].t_val >= 0;
						tmpl_i++ )
					{
						if ( tmpltoks[tmpl_i].t_val
							== tmplchar )
						{
							break;
						}
					}
					printf( "%s\n", tmpltoks[tmpl_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *tmplxi = tmplexca;

				while ( ( *tmplxi != -1 ) ||
					( tmplxi[1] != tmpl_state ) )
				{
					tmplxi += 2;
				}
				while ( ( *(tmplxi += 2) >= 0 ) &&
					( *tmplxi != tmplchar ) )
					;
				if ( ( tmpl_n = tmplxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( tmpl_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( tmplerrflag )
			{
			case 0:		/* new error */
				tmplerror( "syntax error" );
				goto skip_init;
			tmplerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				tmpl_pv = tmplpv;
				tmpl_ps = tmplps;
				tmpl_state = tmplstate;
			skip_init:
				tmplnerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				tmplerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( tmpl_ps >= tmpls )
				{
					tmpl_n = tmplpact[ *tmpl_ps ] + YYERRCODE;
					if ( tmpl_n >= 0 && tmpl_n < YYLAST &&
						tmplchk[tmplact[tmpl_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						tmpl_state = tmplact[ tmpl_n ];
						goto tmpl_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( tmpldebug )
						printf( _POP_, *tmpl_ps,
							tmpl_ps[-1] );
#	undef _POP_
#endif
					tmpl_ps--;
					tmpl_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( tmpldebug )
				{
					register int tmpl_i;

					printf( "Error recovery discards " );
					if ( tmplchar == 0 )
						printf( "token end-of-file\n" );
					else if ( tmplchar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( tmpl_i = 0;
							tmpltoks[tmpl_i].t_val >= 0;
							tmpl_i++ )
						{
							if ( tmpltoks[tmpl_i].t_val
								== tmplchar )
							{
								break;
							}
						}
						printf( "token %s\n",
							tmpltoks[tmpl_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( tmplchar == 0 )	/* reached EOF. quit */
					YYABORT;
				tmplchar = -1;
				goto tmpl_newstate;
			}
		}/* end if ( tmpl_n == 0 ) */
		/*
		** reduction by production tmpl_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( tmpldebug )
			printf( "Reduce by (%d) \"%s\"\n",
				tmpl_n, tmplreds[ tmpl_n ] );
#endif
		tmpltmp = tmpl_n;			/* value to switch over */
		tmplpvt = tmpl_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using tmpl_state here as temporary
		** register variable, but why not, if it works...
		** If tmplr2[ tmpl_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto tmpl_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int tmpl_len = tmplr2[ tmpl_n ];

			if ( !( tmpl_len & 01 ) )
			{
				tmpl_len >>= 1;
				tmplval = ( tmpl_pv -= tmpl_len )[1];	/* $$ = $1 */
				tmpl_state = tmplpgo[ tmpl_n = tmplr1[ tmpl_n ] ] +
					*( tmpl_ps -= tmpl_len ) + 1;
				if ( tmpl_state >= YYLAST ||
					tmplchk[ tmpl_state =
					tmplact[ tmpl_state ] ] != -tmpl_n )
				{
					tmpl_state = tmplact[ tmplpgo[ tmpl_n ] ];
				}
				goto tmpl_stack;
			}
			tmpl_len >>= 1;
			tmplval = ( tmpl_pv -= tmpl_len )[1];	/* $$ = $1 */
			tmpl_state = tmplpgo[ tmpl_n = tmplr1[ tmpl_n ] ] +
				*( tmpl_ps -= tmpl_len ) + 1;
			if ( tmpl_state >= YYLAST ||
				tmplchk[ tmpl_state = tmplact[ tmpl_state ] ] != -tmpl_n )
			{
				tmpl_state = tmplact[ tmplpgo[ tmpl_n ] ];
			}
		}
					/* save until reenter driver code */
		tmplstate = tmpl_state;
		tmplps = tmpl_ps;
		tmplpv = tmpl_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( tmpltmp )
	{
		
case 4:{ EndTemplate(templateLineno); } break;
case 5:{ NewObjTemplate(templateLineno, tmplpvt[-0].identifier); free(tmplpvt[-0].identifier); } break;
case 6:{ NewClassTemplate(templateLineno, tmplpvt[-0].identifier); free(tmplpvt[-0].identifier); } break;
case 7:{ NewAppTemplate(templateLineno, tmplpvt[-0].identifier); free(tmplpvt[-0].identifier); } break;
case 11:{ ProcessBooleanField(templateLineno, tmplpvt[-2].identifier, tmplpvt[-0].bool); free(tmplpvt[-2].identifier); } break;
case 12:{ ProcessIntegerField(templateLineno, tmplpvt[-2].identifier, tmplpvt[-0].integer); free(tmplpvt[-2].identifier); } break;
case 13:{ ProcessStringField(templateLineno, tmplpvt[-2].identifier, tmplpvt[-0].string); free(tmplpvt[-2].identifier); free(tmplpvt[-0].string); } break;
case 14:{ ProcessStringListField(templateLineno, tmplpvt[-4].identifier); free(tmplpvt[-4].identifier); } break;
case 15:{ ProcessStringListField(templateLineno, tmplpvt[-3].identifier); free(tmplpvt[-3].identifier); } break;
case 16:{ ProcessProcField(templateLineno, tmplpvt[-4].identifier, tmplpvt[-1].identifier); free(tmplpvt[-4].identifier); free(tmplpvt[-1].identifier); } break;
case 17:{ TmplAddToStringList(templateLineno, tmplpvt[-0].string); free(tmplpvt[-0].string); } break;
case 18:{ TmplAddToStringList(templateLineno, tmplpvt[-0].string); free(tmplpvt[-0].string); } break;
	}
	goto tmplstack;		/* reset registers in driver code */
}

